@make(ais)
@aiInfo(topic=<Index subtype of an array aggregate>,
number=[AI-00265/05],
classcode=[ra],
statuscode=[WJ],
mainref=[04.03.02@\(11)],
date=[87-06-18])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class ramification 84-07-29
!status approved by WG9/AJPO 87-06-17
@end(toplines)
!status approved by Director, AJPO 87-06-17
!status approved by WG9 87-05-29
!status approved by Ada Board (21-0-0) 87-02-19
!status panel/committee-approved 86-10-15 (reviewed)
!status panel/committee-approved (5-0-0) 86-09-11 (pending editorial review)
!status work-item 86-08-12
!status received 84-07-29
@references[!references 83-00394, @CommentNum[83-00394]83-00394]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 86-09-17]

The index subtype of an array type declared by a constrained array definition
is the subtype defined by the corresponding discrete range.

@subheading[!question 86-09-17]

Consider the following example:
@begin(example)
@key[declare]
    @key[subtype] SUB @key[is] INTEGER @key[range] 1 .. 3;
    A : @key[array] (SUB) @key[of] INTEGER;
    B : @key[array] (1 .. 3) @key[of] INTEGER;
    C : @key[array] (INTEGER @key[range] 1 .. 3) @key[of] INTEGER;
@key[begin]
    A := (2=>0, 3=>0, 4=>0);   -- CONSTRAINT_@|ERROR? (yes)
    B := (2=>0, 3=>0, 4=>0);   -- CONSTRAINT_@|ERROR? (yes)
    C := (2=>0, 3=>0, 4=>0);   -- CONSTRAINT_@|ERROR? (yes)
@end(example)
Is CONSTRAINT_@|ERROR raised for any of these cases?

In answering the above question, note 4.3.2(11):
@begin(quotation)
a check is made that the index @i[values] defined by choices belong
to the corresponding index subtypes
@end(quotation)
What is the index subtype for each index of these array aggregates?

@subheading[!response 86-09-17]

For an unconstrained array, 3.6(5) states:
@begin(quotation)
The index subtype for a given index position is, by definition,
the subtype denoted by the type mark of the corresponding index
subtype definition.
@end(quotation)
For a constrained array type definition, 3.6(7) states:
@begin(quotation)
The array type is an  implicitly declared anonymous type;  this
type  is   defined  by   an  (implicit)   unconstrained   array
definition, in which the  component subtype indication is  that
of the constrained array definition, and in which the type mark
of each index subtype definition denotes the subtype defined by
the corresponding discrete range.
@end(quotation)
Since each of the variables is declared with a constrained array definition,
the index subtype for each of the three types is INTEGER range 1..3.
Consequently, this is the index subtype for each of the aggregates.  Thus,
the check stated in 4.3.2(11) fails when the aggregates are evaluated, and
CONSTRAINT_@|ERROR is raised.

Note that no exception would be raised for
@begin(example)
D : STRING (1 .. 3) := (2 => 'a', 3 => 'b', 4 => 'c');
@end(example)
Since STRING is declared as an unconstrained array type, its index subtype
is POSITIVE, and 4 belongs to the subtype POSITIVE.

